/* Se pasa dos matrices de 2x2 en forma de vector de 4 elementos a una
subrutina en ensamblador que las suma y devuelve otra matriz. En este caso
pasamos por parmetro el nmero de elementos. */
#include <stdlib.h>	/* rand, srand, malloc */
#include <stdio.h>	/* printf */

#define POS(a,b) (a*2 + b)


extern *ensam(int *, int *, int *);

int *matrizA;	/* matriz de conexin entre nodos */
int *matrizB;
int *matrizC;
int n;

/***************************************************************************
 Visualiza una matriz determinada.
****************************************************************************/
void Visualizar(int *m) {
register int i,j;

  for (i = 0; i < 2; i++) {
    printf("\n");
    for (j = 0; j < 2; j++)
      printf("%d ", m[POS(i,j)]);
  }
}

int main(void) {
register int i,j;

  n = 4;
  matrizA = (int *) malloc(n * sizeof(int));
  matrizB = (int *) malloc(n * sizeof(int));
  matrizC = (int *) malloc(n * sizeof(int));
  for (i = 0; i < 2; i++)
    for (j = 0; j < 2; j++)
      matrizA[POS(i,j)] = matrizB[POS(i,j)] = i+1 +j;
  Visualizar(matrizA);
  printf("\n");
  Visualizar(matrizB);

  matrizC = ensam(matrizA,matrizB, &n);
  Visualizar(matrizC);
  return 0;
}