;********** Subrutina en ensamblador: algo1.asm
;   Esta subrutina inicia el vector de etiquetado a FALSE, el de distancia
; INF, el predecesor de s a 0 y su distancia tambin a 0. Se reciben 5
; parmetros: los vectores de distancia, etiquetado y predecesores, el nodo
; inicial y el n de nodos. Para poner a FALSE los elementos del vector
; bastar con ponen un 0 en las celdas.

;  for (i = 0; i < mnodos; i++) {
;    d[i] = INF;
;    etiquetado[i] = FALSE;
;  }
;  d[s] = 0;
;  pred[s] = 0;

.model small, c  ; Se indica modelo de memoria y el convenio de nombres del C
public Algoritmo1    ; exportamos el nombre del procedimiento

.data
i dw 0
n dw 0		; n de nodos
paso dw 2
d dw ?		; direccin de comienzo del vector d
etiq dw ?	; direccin de comienzo del vector etiquetado
pred dw ?	; direccin de comienzo del vector pred
s dw 0		; nodo inicial

.code
Algoritmo1 proc

ARG   su1:PTR,su2:PTR,su3:PTR,su4:PTR,su5:PTR

PUSH AX
PUSH BX
PUSH CX
PUSH DX
PUSH SI
PUSH DI

MOV SI, su1	; vector d
MOV d, SI

MOV SI, su2	; vector etiq
MOV etiq, SI

MOV SI, su3	; vector pred
MOV pred, SI

MOV SI, su4
MOV AX, [SI]
MOV s, AX	; nodo inicial

MOV SI, su5
MOV CX, [SI]
MOV n, CX	; n de nodos

bucle_i: MOV i, CX
	 DEC i

	 MOV AX, i		; se calcula la posicin del
	 MUL paso		; elemento i-simo
	 MOV SI,AX		; SI desplazamiento dentro del vector
	 MOV BX, etiq		; BX como base del vector etiquetado
	 XOR AX, AX		; AX = 0
	 MOV [BX][SI], AX       ; elemento i = FALSE
	 MOV AX, 32767		; AX = INF
	 MOV BX, d		; BX como base para el vector d
	 MOV [BX][SI], AX	; elemento i = INF

	 LOOP bucle_i

MOV AX, s		; se calcula la posicin del nodo inicial
MUL paso		; en el vector
MOV SI, AX      	; desplazamiento dentro del vector en SI
MOV BX, d		; BX base para d
XOR AX, AX		; AX = 0
MOV [BX][SI], AX	; d[s] = 0
MOV BX, pred		; BX base para pred
MOV [BX][SI], AX	; pred[s] = 0
MOV SI, d

POP DI
POP SI
POP DX
POP CX
POP BX
POP AX

ret
endp		; fin del procedimiento

end