;********** Subrutina en ensamblador: iguala.asm
;   Esta subrutina iguala la matriz pasada como primer parmetro con la
; pasada como segundo parmetro.

.model small, c  ; Se indica modelo de memoria y el convenio de nombres del C
public Igualar      ; exportamos el nombre del procedimiento

.data
i dw 0
j dw 0
n dw 0
paso dw 2

.code


Igualar proc

ARG   su1:PTR,su2:PTR,su3:PTR  ; directiva simplificada para acceder a parmetros

PUSH AX
PUSH BX
PUSH CX
PUSH DX
PUSH SI
PUSH DI

MOV DX, su1 	; matriz final
MOV BX, su2	; matriz furente
MOV SI, su3
MOV CX, [SI]
MOV n, CX	; n de filas

bucle_i: MOV i, CX
	 DEC i
	 PUSH CX
	 MOV CX, [su3]
; el elemento (i,j) est en la posicin  i * n + j
bucle_j: MOV j, CX
	 DEC j
	 PUSH DX	; se necesita la dirrecin de DX ms adelante y
			; en la multiplicacin de pierde

	 MOV AX, i      ; se calcula la posicin  del elemento (i,j)
	 MUL n
	 ADD AX, j
	 MUL paso	; un int son 2 word
	 MOV SI, AX	; se guarda en SI

	 MOV AX, [BX][SI] 	; se pasa el dato de BX+SI a DX+SI
	 POP DX
	 PUSH BX
	 MOV BX, DX
	 MOV [BX][SI], AX
	 POP BX

	 LOOP bucle_j
	 POP CX
	 LOOP bucle_i

POP DI
POP SI
POP DX
POP CX
POP BX
POP AX

ret
endp		; fin del procedimiento

end